#
/*			Copyright 1977 by Bill Webb.	 		*/
 
#define	NOEXPAND	01

struct line
{
int l_length;		/* length of the text */
struct line *l_ptr;	/* pointer to more text */
char l_text[DUMMYVEC];	/* current text */
};

struct textp
{
int t_length;		/* length of text */
char *t_ptr;		/* pointer to the text */
char t_text[DUMMYVEC];	/* dummy place holder */
};
 
#define LSIZE ((sizeof (struct line))-DUMMYVEC)
#define TSIZE ((sizeof (struct line))-DUMMYVEC)
 
 
struct macro 
{
struct macro *m_next;
char m_sw;              /* macro in use */
char m_type;            /* macro, fn etc */
char m_len;             /* length of string */
char m_n;               /* number of parameters specified */
struct line m_rdr;      /* reader for text lines */
struct line m_rem;      /* remnant pointer */
struct textp m_par;      /* parameter list ptr */
struct line m_pars[9];  /* parameters themselves */
struct line m_chain;    /* rest of the text */
};

#define	FN_WORK	5	/* number of words in fn work area */
 
struct FUNCTION 
{
struct macro f_junk;
int (*m_fn)();          /* function address */
char m_fname[8];        /* function entry point name */
char *fn_work[FN_WORK];	/* work area for functions */
} *fn_cc;		/* dummy function for control cards */
 
struct 
{
struct macro m_junk;
char m_text[DUMMYVEC];
};
 
#define T_INPUT 0
#define T_INCLUDE 1
#define T_MACRO 2
#define T_FN 3
#define T_AGAIN 4
 
struct macro *rd_next;
struct macro incl;
struct macro rd_again;
#define MSIZE sizeof rd_again 
 
#define MAXMAC 32            /* maximum length of macro name */
char mac_name[MAXMAC];
 
struct mac 
{
char *m_name;
struct macro *m_ptr;
};
 
int mac_cnt;                      /* current number of macros defined */

int macs_use[5];		/* macro etc use counts */

#define mac_use macs_use[T_MACRO]
#define fn_use macs_use[T_FN]

char *fn_ptr;		/* pointer to fn parameter list */
struct fntab
{
char *fn_name;
int (*fn_addr)();
} fntab[];

struct fn 
{
int (*faddr)();
char fname[8];
char *fnwork[FN_WORK];
};

struct macro *mac_create();
struct macro *find_mac();
