#include <stdio.h>
#include <ctype.h>
#include "usr.h"


#define CMDBUFSIZ 80
char cmdbuf[CMDBUFSIZ];
char *fgets();

char *index(), *strcpy();
char *badcommand = "%s:Bad command specification:%s";
FILE *fdopen();

unixcmd(cmd, usrline, nf, buf, buflen, fromfile)
char *cmd, *usrline[];
int nf;
char *buf;
int buflen;
FILE *fromfile;
{
	register char *endstr, *prog, *savebuf;

	if (strlen(cmd) >= CMDBUFSIZ-1)
		err("%s:Unixcmd too long",progname);

			/* make a copy of the unix command
			 * for parsing-don't butcher the original
			 */
	savebuf=strcpy(cmdbuf, cmd);

/* now parse out the details of the unix command for the upto function */
	if((endstr = index(savebuf, '<'))) {
		if(*++endstr != '<')
			err(badcommand, progname, cmd);
		for(prog=endstr-2; isspace(*prog); )
			if(--prog < savebuf)
				err(badcommand, progname, cmd);
		*++prog = '\0';
		for(++endstr; isspace(*endstr); )
			if(!*endstr++)
				err(badcommand, progname, cmd);
	}

/* now process user's data stream thru usr specified unix command */
	return( upto(endstr, savebuf+1, buf, buflen, fromfile, usrline, nf) );
}

upto(endstr, program, buf, bufsiz, fromfile, bp, nf)
register char *endstr;
char *program;
register char *buf;
int bufsiz;
FILE *fromfile;
char *bp[];
int nf;
{
	register FILE *fp;
	int len, i;
	char *eof;

	if(!endstr) {
		system(program);
		return(1);
	}
	else {
		len = strlen(endstr);
		if(!(fp=fdopen(pipeout("/bin/sh", "sh", "-c", program, 0),"w")))
			err("upto:bad pipeout");
		for(i=0; i < nf; i++) {
			if(i) putc(' ',fp);
			fputs(bp[i],fp);
		}
		putc('\n',fp);
		for(;;) {
			if(!(eof=fgets(buf, bufsiz, fromfile))
				|| (*buf==*endstr && !strncmp(endstr,buf,len) ))
					break;
			fputs(buf,fp);
		}
	}

	fclose(fp);
	wait();
	return( (eof) ? (1) : (EOF) );
}

char *index(s,c)
register char *s, c;
{
	register char tmp;

	while (c != (tmp = *s) && tmp)
		++s;
	return( (tmp) ? (s) : (0) );
}
